Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 1763)
+++ test/bfs_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/bfs_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/counter_test.cc
===================================================================
--- test/counter_test.cc	(revision 1847)
+++ test/counter_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/counter_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 1763)
+++ test/dfs_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/dfs_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 1763)
+++ test/dijkstra_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/dijkstra_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/error_test.cc
===================================================================
--- test/error_test.cc	(revision 1435)
+++ test/error_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/error_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/graph_adaptor_test.cc
===================================================================
--- test/graph_adaptor_test.cc	(revision 1435)
+++ test/graph_adaptor_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/graph_adaptor_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/graph_factory_test.cc
===================================================================
--- test/graph_factory_test.cc	(revision 1435)
+++ test/graph_factory_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/graph_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/graph_test.h
===================================================================
--- test/graph_test.h	(revision 1728)
+++ test/graph_test.h	(revision 1875)
@@ -2,5 +2,5 @@
  * test/graph_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/graph_utils_test.h
===================================================================
--- test/graph_utils_test.h	(revision 1568)
+++ test/graph_utils_test.h	(revision 1875)
@@ -2,5 +2,5 @@
  * test/graph_utils_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/kruskal_test.cc
===================================================================
--- test/kruskal_test.cc	(revision 1557)
+++ test/kruskal_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/kruskal_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/map_test.h
===================================================================
--- test/map_test.h	(revision 1675)
+++ test/map_test.h	(revision 1875)
@@ -2,5 +2,5 @@
  * test/map_test.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/max_matching_test.cc
===================================================================
--- test/max_matching_test.cc	(revision 1494)
+++ test/max_matching_test.cc	(revision 1875)
@@ -3,5 +3,5 @@
  * Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/min_cost_flow_test.cc
===================================================================
--- test/min_cost_flow_test.cc	(revision 1435)
+++ test/min_cost_flow_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/min_cost_flow_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/path_test.cc
===================================================================
--- test/path_test.cc	(revision 1435)
+++ test/path_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/path_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/preflow_test.cc
===================================================================
--- test/preflow_test.cc	(revision 1435)
+++ test/preflow_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/preflow_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/suurballe_test.cc
===================================================================
--- test/suurballe_test.cc	(revision 1435)
+++ test/suurballe_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/suurballe_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/test_tools.h
===================================================================
--- test/test_tools.h	(revision 1728)
+++ test/test_tools.h	(revision 1875)
@@ -2,5 +2,5 @@
  * test/test_tools.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/test_tools_fail.cc
===================================================================
--- test/test_tools_fail.cc	(revision 1435)
+++ test/test_tools_fail.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/test_tools_fail.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/test_tools_pass.cc
===================================================================
--- test/test_tools_pass.cc	(revision 1435)
+++ test/test_tools_pass.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/test_tools_pass.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/time_measure_test.cc
===================================================================
--- test/time_measure_test.cc	(revision 1847)
+++ test/time_measure_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/time_measure_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/unionfind_test.cc
===================================================================
--- test/unionfind_test.cc	(revision 1569)
+++ test/unionfind_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/unionfind_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
Index: test/xy_test.cc
===================================================================
--- test/xy_test.cc	(revision 1588)
+++ test/xy_test.cc	(revision 1875)
@@ -2,5 +2,5 @@
  * test/xy_test.cc - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *